<?php
namespace Teknisa\FIN\Factories;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ger38200ImportacaoContasPagarFactory {

    protected $connection;
    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    /**
     * Busca Parametrização Geral
     * @return Paramgeral
     */
    public function buscaParamgeral() {
        $sql = "SELECT DSURLHCM, DSIDHCM, DSSECRETHCM, DSTOKENHCM FROM PARAMGERAL";
        
        $statement = $this->connection->prepare($sql);
        $statement->execute();
        
        return $statement->fetch();
    }
    
}