package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class TitulosAReceberPage extends PageBase {
   // Mapear Tela
    By empresaTituloAReceber = By.xpath("//*[@id='NMEMPRESA']");
    By limparEmpresaTituloAReceber = By.xpath("//*[@id='NMEMPRESA']//*[@id='close-x']");
    By procuraEmpresaTituloAReceber = By.xpath("//*[@id='NMEMPRESA']//*[@id='search']");
    By vencimentoTituloAReceber = By.xpath("//*[@id='DTVENBOLREC']");
    By vencimentoInicialtituloAReceber = By.xpath("//*[@id='DTVENBOLREC_START']");
    By vencimentoFinalTituloAReceber = By.xpath("//*[@id='DTVENBOLREC_END']");
    By motivoProrrogaTituloAReceber = By.xpath("//*[@id='DSMOTIPROR']");
    By procurarMotivoProrrogaTituloAReceber = By.xpath("//*[@id='DSMOTIPROR']//span");
    By limparVencimentoTituloAReceber = By.xpath("//*[@id='DTVENBOLREC']//*[@id='close-x']");
    By aplicarFiltroTitutoAReceber = By.xpath("//span[text()= 'Aplicar filtro']");
    By finalizarTituloAReceber = By.xpath("//span[text()= 'Finalizar']");
    By fecharFiltroTituloAReceber = By.xpath("//span[text()= 'Fechar']");
    By adicionarTituloAReceber = By.xpath("//*[@data-zh-id='7782015843048328682898']");
    By acoesTituloAReceber = By.xpath("//span[text()= 'Ações']");
    By prorrogarTituloAReceber = By.xpath("//span[text()= 'Prorrogar Título']");
    By cadastramentoAutomatico = By.xpath("//span[text()= 'Cadastramento Automático']");
    By importarRetornoTituloAReceber = By.xpath("//span[text()= 'Importar Retorno Título']");
    By unidadeTituloAReceber = By.xpath("//*[@id='NMFILIALEMIT']");
    By limparUnidadeTituloAReceber = By.xpath("//*[@id='NMFILIALEMIT']//*[@id='close-x']");
    By procurarUnidadeTituloAReceber = By.xpath("//*[@id='NMFILIALEMIT']//span");
    By clienteTituloAReceber = By.xpath("//*[@id='NMRAZSOCCLIE']");
    By vrAjusteTituloAReceber = By.xpath("//*[@id='VRAJUSTE']");
    By vrPerAjusteTituloAReceber = By.xpath("//*[@id='VRPERAJUSTE']");
    By descricaoRenogociaTituloAReceber = By.xpath("//*[@id='DSRENEGOFIN']");

    By procurarClienteTituloAReceber = By.xpath("//*[@id='NMRAZSOCCLIE']//span");
    By pesquisaClienteTituloAReceber = By.xpath("//*[@id=\"popup\"]/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By leandroHenriqueFerreira = By.xpath("//span[text()= 'Leandro Henrique Ferreira']");
    By cpf09615452670 = By.xpath("//span[text()= '09615452670']");
    By confirmarTituloAReceber = By.xpath("//span[text()= 'Confirmar']");
    By codigo01 = By.xpath("//span[text()= '01']");
    By codigo0001 = By.xpath("//span[text()= '0001']");
    By codigo02 = By.xpath("//span[text()= '02']");
    By codigo1 = By.xpath("//span[text()= '1']");
    By codigo000001 = By.xpath("//span[text()= '000001']");
    By codigo002 = By.xpath("//span[text()= '002']");
    By tipoOperacaoTituloAReceber = By.xpath("//*[@id='NMTIPOOPER']");

    By procurarTipoOperacaoTituloAReceber = By.xpath("//*[@id='NMTIPOOPER']//span");
    By documentoTituloAReceber = By.xpath("//*[@id='NRNOTAFISC']");
    By serieTituloAReceber = By.xpath("//*[@id='DSSERIE']");
    By limparSerieTituloAReceber = By.xpath("//*[@id='DSSERIE']//*[@id='close-x']");
    By procurarSerieTituloAReceber = By.xpath("//*[@id='DSSERIE']//span");
    By tipoTituloAReceber = By.xpath("//*[@id='IDSTATUS']");
    By dataEmissaoTituloAReceber = By.xpath("//*[@id='DTEMISSAO']");
    By limparDataEmissaoTituloAReceber = By.xpath("//*[@class='zh-select-date zh-field-DTEMISSAO']//*[@id='close-x'");
    By dataSaidaTituloAReceber = By.xpath("//*[@id='DTENTRSAID']");
    By limpaDataSaidaTituloAReceber = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[3]/section/span/ng-include/form/section/div/div[4]/div[3]/div/div[2]/div/span");
    By tipoDeContaTituloAReceber = By.xpath("//*[@id='DSTPCTRECEB']");
    By procurarTpContaTituloReceber = By.xpath("//*[@id='DSTPCTRECEB']//span");
    By vendedorTituloAReceber = By.xpath("//*[@id='NMRAZSOCVEN']");
    By procurarVendedorTituloAReceber = By.xpath("//*[@id='NMRAZSOCVEN']//span");
    By valorTituloAReceber = By.xpath("//*[@id='VRNOTAFISC']");
    By tipoCreditoTituloAReceber = By.xpath("//*[@id='DSTPCREDBANC']");
    By procurarTpCredTituloAReceber = By.xpath("//*[@id='DSTPCREDBANC']//span");
    By valorCreditoTituloAReceber = By.xpath("//*[@id='VRMOVICRED']");


    By dataVencimentoTituloAReceber = By.xpath("//*[@id=\"grid-7782015842283967318710\"]/div[2]/div/div/div[2]/div");
    By informaDTVENCTituloAReceber = By.xpath("//*[@id=\"grid-7782015842283967318710\"]/div[2]/div/div/div[2]/div/input");
    By salvarTituloAReceber = By.xpath("//span[text()= 'Salvar']");
    By salvasAlteracoesTituloAReceber = By.xpath("//span[text()= 'Salvar alterações']");
    By descontarTituloAReceber = By.xpath("//span[text()= 'Descontar Título']");
    By clicarOKTituloAReceber = By.xpath("//span[text()= 'OK']");
    By lupaTituloAReceber = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section[2]/div/section/div[1]/div[2]/div/div[3]/span[3]");
    By lupaLupaTituloAReceber = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section[2]/div/section/div[1]/div[2]/div/div[1]/ul/li[3]/div/div/span[1]");
    By chamarFiltroTituloAReceber = By.xpath("//*[@id='filter']");
    By limparVencimentoFiltroTituloAReceber = By.xpath("//*[@id='DTVENBOLREC']//*[@id='close-x']");
    By clicarDocumentoFiltroTituloAReceber = By.xpath("//span[text()= 'Documento']");
    By nfInicialTitulosAReceber = By.xpath("//*[@id='NRINICIAL']");
    By nfFinalTitulosAReceber = By.xpath("//*[@id='NRFINAL']");
    By editarTituloAReceber = By.xpath("//span[text()= 'Editar']");
    By renogociaTituloAReceber = By.xpath("//span[text()= 'Renegociar Título']");
    By cancRenogociaTituloAReceber = By.xpath("//span[text()= 'Cancelar Renegociação Título']");
    By cancelaBaixaTituloAReceber = By.xpath("//span[text()= 'Cancelar Baixa Título']");
    By excluirTituloAReceber = By.xpath("//span[text()= 'Excluir']");
    By tipoBaixaTituloAReceber = By.xpath("//*[@id='NMTPBAIXAREC']");
    By observacaoTituloAReceber = By.xpath("//*[@id='DSBAIXAREC']");
    By cadastramentoAutTituloAReceber = By.xpath("//span[text()= 'Cadastramento Automático']");
    By botaoBaixaTituloAReceber = By.xpath("//*[@class='zh-container-alert']//span[text()= 'Baixa']");
    By procurarTipoBaixaTitulosAReceber = By.xpath("//*[@id='NMTPBAIXAREC']//span");
    By contaCobrancaTituloAReceber = By.xpath("//*[@id='DSCONTCORR']");
    By procurarContaCobrancaTotuloAReceber = By.xpath("//*[@id='DSCONTCORR']//span");
    By documentoDescontaTituloAReceber = By.xpath("//*[@id='NRDOCMBANC']");
    By descricaoDescontaTituloAReceber = By.xpath("//*[@id='DSMOVICRED']");
    By excluirDocumentoTituloAReceber = By.xpath("//span[text()= 'Documento']");
    By emitirTituloAReceber = By.xpath("//span[text()= 'Emitir Título']");
    By cancelarEmissaoTituloAReceber = By.xpath("//span[text()= 'Cancelar Emissão Título']");
    By cancelarTituloDescontadoAReceber = By.xpath("//span[text()= 'Cancelar Título Descontado']");
    By botaoRemessaTituloAReceber =By.xpath("//button//span[text()= 'Remessa']");
    By gerarRemessaTituloAReceber = By.xpath("//span[text()= 'Gerar Remessa Título']");
    By enviarCartaCobEmailTituloAReceber = By.xpath("//span[text()= 'Enviar Carta de Cobrança por E-mail']");
    By baixarTituloAReceber = By.xpath("//span[text()= 'Baixar Título']");
    By cancelaRemessaTituloAReceber = By.xpath("//span[text()= 'Cancelar Remessa Título']");
    By naoTituloAReceber = By.xpath("//span[text()= 'Não']");

    By voltarTituloAReceber = By.xpath("//span[text()= 'Voltar']");
    By primeiroVencTituloAReceber = By.xpath("//*[@id='DTPRIMVENC']");
    By botaoSimularTituloAReceber = By.xpath("//*[@id='BTNSIMULARENEG']");
    By enviarEmailTituloAReceber = By.xpath("//span[text()= 'Enviar Título por E-mail']");
    By enviarTituloAReceber = By.xpath("//span[text()= 'Enviar']");
    By simTituloAReceber = By.xpath("//span[text()= 'Sim']");
    By marcarTituloAReceber = By.xpath("//*[@data-zh-field-name='__CHECKBOX']//span");
    By marcarRenTituloAreceber = By.xpath("//*[@data-zh-field-name='__CHECKBOX']//*[@class='box']");


    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");


    public void clicarAplicarFiltro (String nfInicial, String nfFinal){
      waitForVisibilityOfElementLocated(loadingWait);
      waitForInvisibilityOfElementLocated(loadingWait);
      click(limparVencimentoFiltroTituloAReceber);
      click(clicarDocumentoFiltroTituloAReceber);
      waitForVisibilityOfElementLocated(nfInicialTitulosAReceber);
      click(nfInicialTitulosAReceber);
      sendKeys(nfInicialTitulosAReceber, nfInicial);
      click(nfFinalTitulosAReceber);
      sendKeys(nfFinalTitulosAReceber,nfFinal);
      click(aplicarFiltroTitutoAReceber);
    }
    public void clicarAdionarTituloAReceber(){
      waitForVisibilityOfElementLocated(adicionarTituloAReceber);
      click(adicionarTituloAReceber);
    }
    public void adicionarTituloAReceber(String cliente, String vrDocumentoRec, String dataVencimento, String nrDocumentoRec){
      click(procurarClienteTituloAReceber);
      click(pesquisaClienteTituloAReceber);
      sendKeys(pesquisaClienteTituloAReceber, cliente);
      click(leandroHenriqueFerreira);
      click(procurarTipoOperacaoTituloAReceber);
      click(codigo01);
      clear(documentoTituloAReceber);
      sendKeys(documentoTituloAReceber, nrDocumentoRec);
      click(limparSerieTituloAReceber);
      click(procurarSerieTituloAReceber);
      click(codigo1);
      click(valorTituloAReceber);
      sendKeys(valorTituloAReceber, vrDocumentoRec);
      click(procurarTpContaTituloReceber);
      click(codigo000001);
      waitForVisibilityOfElementLocated(dataVencimentoTituloAReceber);
      click(dataVencimentoTituloAReceber);
      waitForVisibilityOfElementLocated(informaDTVENCTituloAReceber);
      sendKeys(informaDTVENCTituloAReceber, dataVencimento);
      click(salvarTituloAReceber);
      click(salvasAlteracoesTituloAReceber);
      click(salvarTituloAReceber);
      click(clicarOKTituloAReceber);
    }

    public void alterarExcluirTituloAReceber(){

        click(leandroHenriqueFerreira);
        click(editarTituloAReceber);
        click(procurarTipoBaixaTitulosAReceber);
        click(codigo01);
        click(procurarContaCobrancaTotuloAReceber);
        click(codigo002);
        click(salvarTituloAReceber);
        click(clicarOKTituloAReceber);
        click(excluirTituloAReceber);
        click(excluirDocumentoTituloAReceber);
        click(simTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void prorrogarTituloAReceber(String vencimento){
       click(marcarTituloAReceber);
       click(acoesTituloAReceber);
       click(prorrogarTituloAReceber);
       click(procurarMotivoProrrogaTituloAReceber);
       click(codigo02);
       click(vencimentoTituloAReceber);
       sendKeys(vencimentoTituloAReceber,vencimento);
       click(confirmarTituloAReceber);
       click(clicarOKTituloAReceber);
    }

    public void renegociarTituloAReceber (String descricaoRen, String vrAjusteRen, String percAjusteRen, String dtVencimentoRen) {
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(renogociaTituloAReceber);
        click(descricaoRenogociaTituloAReceber);
        sendKeys(descricaoRenogociaTituloAReceber, descricaoRen);
        clear(vrAjusteTituloAReceber);
        click(vrPerAjusteTituloAReceber);
        sendKeys(vrPerAjusteTituloAReceber, percAjusteRen);
        click(procurarContaCobrancaTotuloAReceber);
        click(codigo002);
        click(primeiroVencTituloAReceber);
        sendKeys(primeiroVencTituloAReceber, dtVencimentoRen);
        click(botaoSimularTituloAReceber);
        click(confirmarTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void cancelaRenegociacaoTitulosAReceber(){
        waitForVisibilityOfElementLocated(marcarRenTituloAreceber);
        click(marcarRenTituloAreceber);
        click(acoesTituloAReceber);
        click(cancRenogociaTituloAReceber);
        click(simTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void emitirTituloAReceber(){
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(emitirTituloAReceber);
        click(simTituloAReceber);
        click(clicarOKTituloAReceber);
        click(marcarRenTituloAreceber);
        click(acoesTituloAReceber);
        click(cancelarEmissaoTituloAReceber);
        click(simTituloAReceber);
        click(naoTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void gerarRemessaTituloAReceber (){
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(gerarRemessaTituloAReceber);
        click(procurarContaCobrancaTotuloAReceber);
        click(codigo002);
        click(confirmarTituloAReceber);
        click(clicarOKTituloAReceber);
        click(marcarRenTituloAreceber);
        click(acoesTituloAReceber);
        click(cancelaRemessaTituloAReceber);
        click(botaoRemessaTituloAReceber);
        click(simTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void enviarEmailTituloAReceber (){
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(enviarEmailTituloAReceber);
        click(simTituloAReceber);
        click(enviarTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void baixarTituloAReceber (String txtObservacao){
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(baixarTituloAReceber);
        click(simTituloAReceber);
        click(procurarContaCobrancaTotuloAReceber);
        click(codigo002);
        click(procurarTipoBaixaTitulosAReceber);
        click(codigo01);
        sendKeys(observacaoTituloAReceber, txtObservacao);
        click(confirmarTituloAReceber);
        click(clicarOKTituloAReceber);
        click(marcarRenTituloAreceber);
        click(acoesTituloAReceber);
        click(cancelaBaixaTituloAReceber);
        click(botaoBaixaTituloAReceber);
        click(simTituloAReceber);
        click(clicarOKTituloAReceber);
   }
    public void cadastramentoAutTituloAReceber (String cliente, String vrDocumento){
        click(aplicarFiltroTitutoAReceber);
        waitForVisibilityOfElementLocated(acoesTituloAReceber);
        click(acoesTituloAReceber);
        click(cadastramentoAutTituloAReceber);
        click(procurarUnidadeTituloAReceber);
        click(codigo0001);
        click(procurarClienteTituloAReceber);
        click(pesquisaClienteTituloAReceber);
        sendKeys(pesquisaClienteTituloAReceber, cliente);
        waitForVisibilityOfElementLocated(leandroHenriqueFerreira);
        click(cpf09615452670);
        click(procurarTipoOperacaoTituloAReceber);
        click(codigo01);
        click(procurarSerieTituloAReceber);
        click(codigo1);
        sendKeys(valorTituloAReceber, vrDocumento);
        click(procurarTpContaTituloReceber);
        click(codigo000001);
        click(finalizarTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void cartaCobrancaEmailTitulosAReceber (){
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(enviarCartaCobEmailTituloAReceber);
        click(enviarTituloAReceber);
        waitForVisibilityOfElementLocated(clicarOKTituloAReceber);
        click(clicarOKTituloAReceber);
    }

    public void descontarTituloAReceber(String vrDocumento, String descricaoDesconto){
        click(marcarTituloAReceber);
        click(acoesTituloAReceber);
        click(descontarTituloAReceber);
        click(procurarTpCredTituloAReceber);
        click(codigo0001);
        sendKeys(valorCreditoTituloAReceber, vrDocumento);
        click(procurarContaCobrancaTotuloAReceber);
        click(codigo002);
        sendKeys(descricaoDescontaTituloAReceber, descricaoDesconto);
        click(finalizarTituloAReceber);
        waitForVisibilityOfElementLocated(clicarOKTituloAReceber);
        click(clicarOKTituloAReceber);
        click(marcarRenTituloAreceber);
        click(acoesTituloAReceber);
        click(cancelarTituloDescontadoAReceber);
        click(simTituloAReceber);
        click(clicarOKTituloAReceber);
    }

}
